#ifndef list_h
#define	list_h

/*
* NIST STEP Core Class Library
* clstepcore/SingleLinkList.h
* February, 1994
* David Sauder
* KC Morris

* Development of this software was funded by the United States Government,
* and is not subject to copyright.
*/

/* $Id: SingleLinkList.h,v 2.0.1.1 1994/04/05 16:36:31 sauderd Exp $ */



class SingleLinkList  {

    // node which represents the value is contained in the subclass
	//  since it may have different types for different lists
    
  protected:
    
    class  SingleLinkNode *  head;
    SingleLinkNode *  tail;

  public:
    
    virtual SingleLinkNode *NewNode();
    virtual void AppendNode (SingleLinkNode *);

    virtual void Empty ();
    virtual SingleLinkNode * GetHead () const;
    
    int EntryCount() const;

    SingleLinkList ();
    virtual ~SingleLinkList ();
    
}
;


class SingleLinkNode {
    friend SingleLinkList;    
  protected:

  public:
    SingleLinkNode* next;

  public:
    virtual SingleLinkNode *NextNode () const;
    SingleLinkNode()  { next =0; }
    virtual ~SingleLinkNode() { }
};

#endif
